#ifndef __LPSOLVE_H
#define __LPSOLVE_H
#include <giac/config.h>
#include <giac/gen.h>
#include <giac/unary.h>

#ifndef NO_NAMESPACE_GIAC
namespace giac {
#endif // ndef NO_NAMESPACE_GIAC

	enum lpsolve_options {
		//                         the function 'lpsolve' should support the following option keywords:
		_LP_ASSUME=0,           //   * assume
		_LP_BINARY=1,           //   * binary
		// _ZINT=2                   * integer
		_LP_BINARYVARIABLES=3,  //   * binaryvariables
		_LP_DEPTHLIMIT=4,       //   * depthlimit
		_LP_INTEGERVARIABLES=5, //   * integervariables
		_LP_MAXIMIZE=6,         //   * maximize
		_LP_NONNEGATIVE=7,      //   * nonnegative
		_LP_NONNEGINT=8,        //   * nonnegint
		_LP_VARIABLES=9         //   * variables
	};
	
	gen lpmax(const matrice & lh,vecteur & rel,vecteur & rh,vecteur & obj_orig,std::vector<bool> & nnegv,GIAC_CONTEXT);
	gen lpmin(const matrice & lh,vecteur & rel,vecteur & rh,vecteur & obj,GIAC_CONTEXT);
	int ilpbb(matrice & lh_orig,vecteur & rel_orig,vecteur & rh_orig,vecteur & obj_orig,
						std::vector<int> & vartype,vecteur & soln,std::vector<bool> & nnegv_orig,vecteur & incumbent,
						bool maximize,int depth,int depthlimit,GIAC_CONTEXT);
  bool is_realcons(const gen & g,GIAC_CONTEXT);
	bool lincomb_coeff(const gen & e_orig,const vecteur & v,vecteur & c,gen & r,GIAC_CONTEXT);
	bool intrv2vec(const gen & g,vecteur & v,GIAC_CONTEXT);
	gen _lpsolve(const gen & args,GIAC_CONTEXT);

  extern const unary_function_ptr * const  at_lpsolve;

#ifndef NO_NAMESPACE_GIAC
} // namespace giac
#endif // ndef NO_NAMESPACE_GIAC
#endif // __LPSOLVE_H
